/**
Released as open source by Gabriel Caudrelier

Developed by Gabriel Caudrelier, gabriel dot caudrelier at gmail dot com

https://github.com/metrodango/pip3line

Released under AGPL see LICENSE for more information
**/

#include "commonstrings.h"

namespace Pip3lineConst {
    // Default types
    const QString DEFAULT_TYPE_ENCODER = "Encoders";
    const QString DEFAULT_TYPE_MISC = "Misc.";
    const QString DEFAULT_TYPE_CRYPTO = "Crypto";
    const QString DEFAULT_TYPE_HACKING = "Hacking";
    const QString DEFAULT_TYPE_HASHES = "Hashes";
    const QString DEFAULT_TYPE_TYPES_CASTING = "Types casting";
    const QString DEFAULT_TYPE_PARSERS = "Parsers";
    const QString DEFAULT_TYPE_NUMBER = "Numbers";
    const QString DEFAULT_TYPE_USER = "User";

    // Default XML tags names
    const QString XMLPIP3LINECONF = "pip3line";
    const QString XMLDESCRIPTION = "Description";
    const QString XMLHELP = "Help";
    const QString XMLVERSIONMAJOR = "Version";
    const QString XMLORDER = "Order";
    const QString PROP_NAME = "Name";
    const QString PROP_WAY = "Way";
    const QString XMLTRANSFORM = "Transform";
    const QString XMLVARIANT = "Variant";
    const QString XMLPADDINGCHAR = "PaddingChar";
    const QString XMLINCLUDEPADDING = "IncludePadding";
    const QString XMLPADDINGTYPE = "PaddingType";
    const QString XMLKEY = "Key";
    const QString XMLFROMHEX = "FromHex";
    const QString XMLPERCENTCHAR = "PercentChar";
    const QString XMLINCLUDE = "Include";
    const QString XMLEXCLUDE = "Exclude";
    const QString XMLCHOOSENTARGET = "ChoosenTarget";
    const QString XMLBLOCKSIZE = "BlockSize";
    const QString XMLNOBLOCK = "NoBlock";
    const QString XMLUSEENTITYNAMES = "UseEntityNames";
    const QString XMLUSEHEXA = "UseHexadecimal";
    const QString XMLENCODEALL = "EncodeAll";
    const QString XMLISESCAPED = "IsEscaped";
    const QString XMLCODECNAME = "CodecName";
    const QString XMLCHAR62 = "Char62";
    const QString XMLCHAR63 = "Char63";
    const QString XMLFROM = "From";
    const QString XMLLENGTH = "Length";
    const QString XMLEVERYTHING = "Everything";
    const QString XMLSEPARATOR = "Separator";
    const QString XMLGROUP = "Group";
    const QString XMLACTIONTYPE = "ActionType";
    const QString XMLGREEDYQUANT = "UseGreedyQuantifiers";
    const QString XMLREGEXP = "RegExpression";
    const QString XMLCASEINSENSITIVE = "CaseInsensitive";
    const QString XMLALLGROUPS = "AllGroups";
    const QString XMLREPLACEWITH = "ReplaceWith";
    const QString XMLBASE = "Base";
    const QString XMLHASHNAME = "HashName";
    const QString XMLUPPERCASE = "UpperCase";
    const QString XMLPROCESSLINEBYLINE = "ProcessLineByLine";
    const QString XMLTYPE = "Type";
    const QString XMLLITTLEENDIAN = "LittleEndian";
    const QString XMLQUERYSTRING = "XMLQuery";
    const QString XMLLEVEL = "Level";
    const QString XMLFORMAT = "Format";
    const QString XMLOUTPUTTYPE = "OutputType";
    const QString XMLAPPENDTOINPUT = "AppendToInput";
    const QString XMLDECODE = "Decode";
    const QString XMLOFFSET = "Offset";
    const QString XMLCLEAN = "Clean";
    const QString XMLAUTORELOAD = "AutoReload";
    const QString XMLTZ = "TimeZone";

    const QString USER_DIRECTORY = ".pip3line";
    const int BLOCK_MAX_SIZE = 0x04000000;
}
